#include <bits/stdc++.h>
#include <experimental/random>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using ordered_set = tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18, MOD = 1e9 + 7;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    ll q = 1;
    while (q--) {
        solve();
    }
}

struct seg_tree {
    struct Node {
        ll mx = -INF, dept = 0;
    };

    vector<Node> tree;

    Node merge(Node a, Node b) {
        Node ans{};
        ans.mx = max(a.mx, b.mx);
        return ans;
    }

    void push(ll v, ll vl, ll vr) {
        tree[v].mx += tree[v].dept;
        if (vr - vl != 1) {
            tree[2 * v].dept += tree[v].dept;
            tree[2 * v + 1].dept += tree[v].dept;
        }
        tree[v].dept = 0;
    }

    void build(ll v, ll l, ll r) {
        if (r - l == 1) {
            tree[v].mx = l;
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m, r);
        tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
    }

    void change(ll v, ll vl, ll vr, ll l, ll r) {
        if (vl >= r || vr <= l) {
            push(v, vl, vr);
            return;
        }
        if (vl >= l && vr <= r) {
            tree[v].dept--;
            push(v, vl, vr);
            return;
        }
        push(v, vl, vr);
        ll m = (vl + vr) / 2;
        change(2 * v, vl, m, l, r);
        change(2 * v + 1, m, vr, l, r);
        tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
    }

    ll get(ll v, ll vl, ll vr, ll l, ll r) {
        push(v, vl, vr);
        if (vl >= r || vr <= l) {
            return -INF;
        }
        if (vl >= l && vr <= r) {
            return tree[v].mx;
        }
        ll m = (vl + vr) / 2;
        return max(get(2 * v, vl, m, l, r), get(2 * v + 1, m, vr, l, r));
    }
};

seg_tree idx;

ll get_r(ll i, ll n) {
    ll l = 0, r = n;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (idx.get(1, 0, n, 0, mid + 1) <= i) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return l;
}

ll get_l(ll i, ll n) {
    ll l = -1, r = n - 1;
    while (r - l > 1) {
        ll mid = (l + r) / 2;
        if (idx.get(1, 0, n, 0, mid + 1) < i) {
            l = mid;
        } else {
            r = mid;
        }
    }
    return r;
}

struct sg_t2 {
    struct Node {
        ll sum = 0, mx = -INF, dept = -1;
    };
    vector<Node> tree;
    void build(ll v, ll l, ll r, vector<ll>& a) {
        if (r - l == 1) {
            tree[v].sum = a[l];
            tree[v].mx = a[l];
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v, l, m, a);
        build(2 * v + 1, m, r, a);
        tree[v].sum = tree[2 * v].sum + tree[2 * v + 1].sum;
        tree[v].mx = max(tree[2 * v].mx, tree[2 * v + 1].mx);
    }
    void push(ll v, ll vl, ll vr) {
        if (tree[v].dept == -1) {
            return;
        }
        tree[v].sum = tree[v].dept * (vr - vl);
        tree[v].mx = tree[v].dept;
        if (vr - vl != 1) {
            tree[2 * v].dept = tree[v].dept;
            tree[2 * v + 1].dept = tree[v].dept;
        }
        tree[v].dept = -1;
    }
    void change(ll v, ll vl, ll vr, ll l, ll r, ll x) {
        if (vl >= r || vr <= l) {
            push(v, vl, vr);
            return;
        }
        if (vl >= l && vr <= r) {
            tree[v].dept = x;
            push(v, vl, vr);
            return;
        }
        push(v, vl, vr);
        ll m = (vl + vr) / 2;
        change(2 * v, vl, m, l, r, x);
        change(2 * v + 1, m, vr, l, r, x);
        tree[v].sum = tree[2 * v].sum + tree[2 * v + 1].sum;
        tree[v].mx = max(tree[2 * v].mx, tree[2 * v + 1].mx);
    }
    ll get(ll v, ll vl, ll vr, ll l, ll r) {
        push(v, vl, vr);
        if (vl >= r || vr <= l) {
            return 0;
        }
        if (vl >= l && vr <= r) {
            return tree[v].sum;
        }
        ll m = (vl + vr) / 2;
        return get(2 * v, vl, m, l, r) + get(2 * v + 1, m, vr, l, r);
    }
    ll get_mx(ll v, ll vl, ll vr, ll l, ll r) {
        push(v, vl, vr);
        if (vl >= r || vr <= l) {
            return -INF;
        }
        if (vl >= l && vr <= r) {
            return tree[v].mx;
        }
        ll m = (vl + vr) / 2;
        return max(get_mx(2 * v, vl, m, l, r), get_mx(2 * v + 1, m, vr, l, r));
    }
};

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n);
    vector<ll> pref = {0};
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pref.push_back(pref.back() + a[i]);
    }
    idx.tree.resize(4 * n);
    idx.build(1, 0, n);
    sg_t2 lf, rf;
    lf.tree.resize(4 * n), rf.tree.resize(4 * n);
    lf.build(1, 0, n, a), rf.build(1, 0, n, a);
    for (int i = 1; i < n; i++) {
        ll k;
        cin >> k;
        k--;
        ll l1 = get_l(k, n);
        ll r1 = get_r(k, n);
        ll l2 = get_l(k + 1, n);
        ll r2 = get_r(k + 1, n);
        idx.change(1, 0, n, l2, n);
        ll l = l1 - 1, r = r1;
        ll mx = rf.get_mx(1, 0, n, l2, r2 + 1);
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (rf.get_mx(1, 0, n, mid, r1 + 1) <= mx) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (rf.get_mx(1, 0, n, r, r1 + 1) <= mx) {
            rf.change(1, 0, n, r, r1 + 1, mx);
        }
        mx = lf.get_mx(1, 0, n, l1, r1 + 1);
        l = l2, r = r2 + 1;
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (lf.get_mx(1, 0, n, l2, mid + 1) <= mx) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (lf.get_mx(1, 0, n, l2, l + 1) <= mx) {
            lf.change(1, 0, n, l2, l + 1, mx);
        }
        l = l1, r = r2 + 1;
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (lf.get_mx(1, 0, n, l1, mid + 1) <= rf.get_mx(1, 0, n, mid, r2 + 1)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        ll t = l;
        if (lf.get_mx(1, 0, n, l1, t + 1) > rf.get_mx(1, 0, n, t, r2 + 1)) {
            t--;
        }
        ll all = pref[t + 1] - pref[l1];
        ll ans = lf.get(1, 0, n, l1, t + 1) - all;
        all = pref[r2 + 1] - pref[t + 1];
        ans += rf.get(1, 0, n, t + 1, r2 + 1) - all;
        cout << ans << '\n';
    }
}
